import ProviderEngine from 'web3-provider-engine';
export declare type TTxParams = any;
export declare type TMsgParams = any;
export declare type TSignature = string;
export interface ICallback {
    (err: Error, result?: any): any;
}
export default class AuthereumProvider extends ProviderEngine {
    authereum: any;
    rpcUri: string;
    readonly isAuthereum: boolean;
    private config;
    private subprovider;
    private rpcSubprovider;
    private lastSignTx;
    private lastSignTxTimeout;
    private lastTx;
    private lastTxTimeout;
    private lastMsg;
    private lastMsgTimeout;
    private lastTypedMsg;
    private lastTypedMsgTimeout;
    constructor(config?: any);
    private initSubprovider;
    private getAccounts;
    isConnected(): any;
    enable(): Promise<any[]>;
    disable(): Promise<any>;
    private tilDomReady;
    sendTransaction(tx: any): Promise<any>;
    sendTransactionBatch(txs: any[]): Promise<any>;
    estimateGasBatch(txs: any[]): Promise<any>;
    sign(msgParams: any): any;
    signMessageWithAdminKey(message: any): any;
    signMessageWithSigningKey(...input: any[]): any;
    showWidget(enabled?: boolean): any;
    widgetEnabled(): any;
    getTransactionReceipt(txHash: string): any;
    waitForTransactionReceipt(txHash: string): any;
    isContractDeployed(accountAddress: string): any;
}
